/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.prob.unicode.lexer;

import java.io.*;
import java.util.*;
import de.prob.unicode.node.*;
import de.hhu.stups.sablecc.patch.*;


@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;

	private IToken tok;

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return this.token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = this.token;
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TIn(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TNotsubseteq(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TNotsubset(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TSubseteq(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TSetminus(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TDotdot(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TNat(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TEmptyset(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TBcmsuch(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TBfalse(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TForall(text, line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TMapsto(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TBtrue(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TSubset(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TBunion(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TBinter(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TDomres(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TRanres(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TDomsub(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TRansub(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TOftype(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TNotin(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TCprod(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TInter(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TFcomp(text, line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TBcomp(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TStrel(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TDprod(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TPprod(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TBcmeq(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TBcmin(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TIntg(text, line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TLand(text, line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TLimp(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TLeqv(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TLnot(text, line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TQdot(text, line, pos); }
    Token new40(  String text,   int line,   int pos) { return new TConv(text, line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TTrel(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TSrel(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TPfun(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TTfun(text, line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TPinj(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TTinj(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TPsur(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TTsur(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TTbij(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TExpn(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TLor(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TMid(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TNeq(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TRel(text, line, pos); }
    Token new56(  String text,   int line,   int pos) { return new TOvl(text, line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TLeq(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TGeq(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TDiv(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TMult(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TAnyChar(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{0, 8, 1}, {9, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 31, 1}, {32, 32, 2}, {33, 33, 3}, {34, 34, 1}, {35, 35, 4}, {36, 36, 1}, {37, 37, 5}, {38, 38, 6}, {39, 39, 1}, {40, 41, 2}, {42, 42, 7}, {43, 43, 8}, {44, 44, 2}, {45, 45, 9}, {46, 46, 10}, {47, 47, 11}, {48, 57, 1}, {58, 58, 12}, {59, 59, 13}, {60, 60, 14}, {61, 61, 15}, {62, 62, 16}, {63, 72, 1}, {73, 73, 17}, {74, 77, 1}, {78, 78, 18}, {79, 79, 1}, {80, 80, 19}, {81, 84, 1}, {85, 85, 20}, {86, 91, 1}, {92, 92, 21}, {93, 93, 1}, {94, 94, 22}, {95, 98, 1}, {99, 99, 23}, {100, 101, 1}, {102, 102, 24}, {103, 109, 1}, {110, 110, 25}, {111, 111, 26}, {112, 115, 1}, {116, 116, 27}, {117, 122, 1}, {123, 123, 28}, {124, 124, 29}, {125, 125, 2}, {126, 126, 30}, {127, 171, 1}, {172, 172, 31}, {173, 182, 1}, {183, 183, 32}, {184, 214, 1}, {215, 215, 33}, {216, 246, 1}, {247, 247, 34}, {248, 954, 1}, {955, 955, 35}, {956, 8228, 1}, {8229, 8229, 36}, {8230, 8468, 1}, {8469, 8469, 37}, {8470, 8472, 1}, {8473, 8473, 38}, {8474, 8483, 1}, {8484, 8484, 39}, {8485, 8593, 1}, {8594, 8594, 40}, {8595, 8595, 1}, {8596, 8596, 41}, {8597, 8607, 1}, {8608, 8608, 42}, {8609, 8610, 1}, {8611, 8611, 43}, {8612, 8613, 1}, {8614, 8614, 44}, {8615, 8657, 1}, {8658, 8658, 45}, {8659, 8659, 1}, {8660, 8660, 46}, {8661, 8695, 1}, {8696, 8696, 47}, {8697, 8703, 1}, {8704, 8704, 48}, {8705, 8706, 1}, {8707, 8707, 49}, {8708, 8708, 1}, {8709, 8709, 50}, {8710, 8711, 1}, {8712, 8712, 51}, {8713, 8713, 52}, {8714, 8721, 1}, {8722, 8722, 53}, {8723, 8725, 1}, {8726, 8726, 54}, {8727, 8727, 55}, {8728, 8728, 56}, {8729, 8738, 1}, {8739, 8739, 57}, {8740, 8740, 1}, {8741, 8741, 58}, {8742, 8742, 1}, {8743, 8743, 59}, {8744, 8744, 60}, {8745, 8745, 61}, {8746, 8746, 62}, {8747, 8763, 1}, {8764, 8764, 63}, {8765, 8787, 1}, {8788, 8788, 64}, {8789, 8799, 1}, {8800, 8800, 65}, {8801, 8803, 1}, {8804, 8804, 66}, {8805, 8805, 67}, {8806, 8833, 1}, {8834, 8834, 68}, {8835, 8835, 1}, {8836, 8836, 69}, {8837, 8837, 1}, {8838, 8838, 70}, {8839, 8839, 1}, {8840, 8840, 71}, {8841, 8854, 1}, {8855, 8855, 72}, {8856, 8867, 1}, {8868, 8868, 73}, {8869, 8869, 74}, {8870, 8897, 1}, {8898, 8898, 75}, {8899, 8899, 76}, {8900, 9654, 1}, {9655, 9655, 77}, {9656, 9664, 1}, {9665, 9665, 78}, {9666, 10495, 1}, {10496, 10496, 79}, {10497, 10515, 1}, {10516, 10516, 80}, {10517, 10517, 1}, {10518, 10518, 81}, {10519, 10625, 1}, {10626, 10626, 82}, {10627, 10851, 1}, {10852, 10852, 83}, {10853, 10853, 84}, {10854, 57599, 1}, {57600, 57600, 85}, {57601, 57601, 86}, {57602, 57602, 87}, {57603, 57603, 88}, {57604, 65535, 1}, },
            {{0, 8, 1}, {11, 12, 1}, {14, 31, 1}, {34, 34, 1}, {36, 36, 1}, {38, 39, 1}, {48, 57, 1}, {63, 91, 1}, {93, 93, 1}, {95, 122, 1}, {127, 171, 1}, {173, 182, 1}, {184, 214, 1}, {216, 246, 1}, {248, 954, 1}, {956, 8228, 1}, {8230, 8468, 1}, {8470, 8472, 1}, {8474, 8483, 1}, {8485, 8593, 1}, {8595, 8595, 1}, {8597, 8607, 1}, {8609, 8610, 1}, {8612, 8613, 1}, {8615, 8657, 1}, {8659, 8659, 1}, {8661, 8695, 1}, {8697, 8703, 1}, {8705, 8706, 1}, {8708, 8708, 1}, {8710, 8711, 1}, {8714, 8721, 1}, {8723, 8725, 1}, {8729, 8738, 1}, {8740, 8740, 1}, {8742, 8742, 1}, {8747, 8763, 1}, {8765, 8787, 1}, {8789, 8799, 1}, {8801, 8803, 1}, {8806, 8833, 1}, {8835, 8835, 1}, {8837, 8837, 1}, {8839, 8839, 1}, {8841, 8854, 1}, {8856, 8867, 1}, {8870, 8897, 1}, {8900, 9654, 1}, {9656, 9664, 1}, {9666, 10495, 1}, {10497, 10515, 1}, {10517, 10517, 1}, {10519, 10625, 1}, {10627, 10851, 1}, {10854, 57599, 1}, {57604, 65535, 1}, },
            {},
            {},
            {},
            {},
            {{0, 65535, -3}, },
            {{42, 42, 89}, },
            {{45, 45, 90}, {62, 62, 91}, },
            {{45, 45, 92}, {62, 62, 93}, },
            {{46, 46, 94}, },
            {{58, 58, 95}, {60, 60, 96}, {61, 61, 97}, {92, 92, 98}, },
            {{58, 58, 99}, {61, 61, 100}, {124, 124, 101}, {8712, 8712, 102}, {8739, 8739, 103}, },
            {},
            {{43, 43, 104}, {45, 45, 105}, {58, 58, 106}, {60, 60, 107}, {61, 61, 108}, {124, 124, 109}, },
            {{62, 62, 110}, },
            {{43, 43, 111}, {45, 45, 112}, {60, 60, 113}, {61, 61, 114}, },
            {{0, 57, -3}, {63, 77, 1}, {78, 78, 115}, {79, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 64, 1}, {65, 65, 116}, {66, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 78, 1}, {79, 79, 117}, {80, 91, 1}, {93, 65535, -3}, },
            {{0, 77, -19}, {78, 78, 118}, {79, 65535, -19}, },
            {{47, 47, 119}, {48, 48, 120}, {73, 73, 121}, {85, 85, 122}, {98, 98, 123}, {99, 99, 124}, {100, 100, 125}, {101, 101, 126}, {102, 102, 127}, {103, 103, 128}, {105, 105, 129}, {108, 108, 130}, {109, 109, 131}, {110, 110, 132}, {111, 111, 133}, {112, 112, 134}, {113, 113, 135}, {114, 114, 136}, {115, 115, 137}, {116, 116, 138}, },
            {},
            {{0, 93, -3}, {95, 104, 1}, {105, 105, 139}, {106, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 96, 1}, {97, 97, 140}, {98, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 110, 1}, {111, 111, 141}, {112, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 101, 1}, {102, 102, 142}, {103, 113, 1}, {114, 114, 143}, {115, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 113, 1}, {114, 114, 144}, {115, 65535, -28}, },
            {{125, 125, 145}, },
            {{45, 45, 146}, {62, 62, 147}, {124, 124, 148}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 149}, },
            {{62, 62, 150}, },
            {{62, 62, 151}, },
            {{62, 62, 152}, },
            {},
            {},
            {{58, 58, 153}, {60, 60, 154}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 155}, },
            {},
            {{45, 45, 156}, {58, 58, 157}, {124, 124, 158}, },
            {{62, 62, 159}, },
            {},
            {},
            {{62, 62, 160}, },
            {{62, 62, 161}, },
            {},
            {},
            {{0, 57, -3}, {63, 83, 1}, {84, 84, 162}, {85, 91, 1}, {93, 65535, -3}, },
            {{0, 83, -117}, {84, 84, 163}, {85, 65535, -117}, },
            {{0, 57, -3}, {63, 86, 1}, {87, 87, 164}, {88, 91, 1}, {93, 65535, -3}, },
            {{0, 57, -3}, {63, 72, 1}, {73, 73, 165}, {74, 91, 1}, {93, 65535, -3}, },
            {},
            {{120, 120, 166}, },
            {{110, 110, 167}, },
            {{110, 110, 168}, },
            {{99, 99, 169}, {102, 102, 170}, {105, 105, 171}, {116, 116, 172}, {117, 117, 173}, },
            {{111, 111, 174}, {112, 112, 175}, },
            {{105, 105, 176}, {111, 111, 177}, {112, 112, 178}, },
            {{109, 109, 179}, {120, 120, 180}, },
            {{99, 99, 181}, {111, 111, 182}, },
            {{101, 101, 183}, },
            {{110, 110, 184}, },
            {{97, 97, 185}, {101, 101, 186}, {105, 105, 187}, {110, 110, 188}, {111, 111, 189}, },
            {{97, 97, 190}, {105, 105, 191}, },
            {{97, 97, 192}, {101, 101, 193}, {111, 111, 194}, },
            {{102, 102, 195}, {118, 118, 196}, },
            {{102, 102, 197}, {105, 105, 198}, {111, 111, 199}, {112, 112, 200}, {115, 115, 201}, },
            {{100, 100, 202}, },
            {{97, 97, 203}, {101, 101, 204}, },
            {{101, 101, 205}, {114, 114, 206}, {116, 116, 207}, {117, 117, 208}, },
            {{98, 98, 209}, {102, 102, 210}, {105, 105, 211}, {114, 114, 212}, {115, 115, 213}, },
            {{0, 113, -29}, {114, 114, 214}, {115, 65535, -28}, },
            {{0, 93, -3}, {95, 107, 1}, {108, 108, 215}, {109, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 115, 1}, {116, 116, 216}, {117, 122, 1}, {127, 65535, -3}, },
            {{0, 115, -143}, {116, 116, 217}, {117, 65535, -143}, },
            {{0, 65535, -3}, },
            {{0, 93, -3}, {95, 116, 1}, {117, 117, 218}, {118, 122, 1}, {127, 65535, -3}, },
            {},
            {{62, 62, 219}, },
            {{62, 62, 220}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{58, 58, 221}, },
            {{62, 62, 222}, },
            {{62, 62, 223}, },
            {},
            {},
            {},
            {},
            {{62, 62, 224}, },
            {{0, 57, -3}, {63, 68, 1}, {69, 69, 225}, {70, 91, 1}, {93, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 78, -21}, {79, 79, 226}, {80, 65535, -21}, },
            {{112, 112, 227}, },
            {{116, 116, 228}, },
            {{105, 105, 229}, },
            {{109, 109, 230}, {111, 111, 231}, },
            {{97, 97, 232}, },
            {{110, 110, 233}, },
            {{114, 114, 234}, },
            {{110, 110, 235}, },
            {{110, 110, 236}, },
            {{114, 114, 237}, },
            {{118, 118, 238}, },
            {{109, 109, 239}, },
            {{114, 114, 240}, },
            {{112, 112, 241}, },
            {{105, 105, 242}, {112, 112, 243}, },
            {{111, 111, 244}, },
            {{114, 114, 245}, },
            {{113, 113, 246}, },
            {{116, 116, 247}, },
            {{109, 109, 248}, {110, 110, 249}, },
            {{113, 113, 250}, },
            {{109, 109, 251}, },
            {{111, 111, 252}, },
            {{114, 114, 253}, },
            {{112, 112, 254}, },
            {{100, 100, 255}, },
            {{116, 116, 256}, },
            {{113, 113, 257}, },
            {{116, 116, 258}, },
            {{116, 116, 259}, },
            {{108, 108, 260}, },
            {{117, 117, 261}, },
            {{110, 110, 262}, },
            {{119, 119, 263}, },
            {{114, 114, 264}, },
            {{117, 117, 265}, },
            {{111, 111, 266}, },
            {{110, 110, 267}, },
            {{108, 108, 268}, },
            {{116, 116, 269}, },
            {{101, 101, 270}, },
            {{114, 114, 271}, },
            {{98, 98, 272}, },
            {{105, 105, 273}, },
            {{117, 117, 274}, },
            {{110, 110, 275}, },
            {{101, 101, 276}, },
            {{117, 117, 277}, },
            {{0, 93, -3}, {95, 98, 1}, {99, 99, 278}, {100, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 114, 1}, {115, 115, 279}, {116, 122, 1}, {127, 65535, -3}, },
            {{0, 65535, -3}, },
            {{0, 93, -3}, {95, 120, 1}, {121, 121, 280}, {122, 122, 1}, {127, 65535, -3}, },
            {{0, 93, -3}, {95, 100, 1}, {101, 101, 281}, {102, 122, 1}, {127, 65535, -3}, },
            {},
            {},
            {},
            {},
            {{62, 62, 282}, },
            {},
            {{0, 57, -3}, {63, 81, 1}, {82, 82, 283}, {83, 91, 1}, {93, 65535, -3}, },
            {{0, 77, -19}, {78, 78, 284}, {79, 65535, -19}, },
            {{116, 116, 285}, },
            {{101, 101, 286}, },
            {{111, 111, 287}, },
            {{101, 101, 288}, {105, 105, 289}, {115, 115, 290}, },
            {{109, 109, 291}, },
            {{108, 108, 292}, },
            {{116, 116, 293}, },
            {{117, 117, 294}, },
            {{105, 105, 295}, },
            {{118, 118, 296}, },
            {{111, 111, 297}, },
            {},
            {{114, 114, 298}, {115, 115, 299}, },
            {{111, 111, 300}, },
            {{116, 116, 301}, },
            {{115, 115, 302}, },
            {{110, 110, 303}, },
            {{109, 109, 304}, },
            {{97, 97, 305}, },
            {},
            {{103, 103, 306}, },
            {{98, 98, 307}, },
            {{100, 100, 308}, },
            {{118, 118, 309}, },
            {{112, 112, 310}, },
            {{116, 116, 311}, },
            {},
            {{115, 115, 312}, },
            {},
            {},
            {},
            {{105, 105, 313}, {115, 115, 314}, },
            {{121, 121, 315}, },
            {},
            {{110, 110, 316}, },
            {{106, 106, 317}, },
            {},
            {{111, 111, 318}, },
            {{114, 114, 319}, },
            {{116, 116, 320}, },
            {{114, 114, 321}, {115, 115, 322}, },
            {},
            {{109, 109, 323}, },
            {{108, 108, 324}, },
            {{101, 101, 325}, },
            {{115, 115, 326}, },
            {{106, 106, 327}, },
            {{110, 110, 328}, },
            {{106, 106, 329}, },
            {{108, 108, 330}, },
            {{114, 114, 331}, },
            {{0, 65535, -3}, },
            {{0, 100, -220}, {101, 101, 332}, {102, 65535, -220}, },
            {{0, 93, -3}, {95, 111, 1}, {112, 112, 333}, {113, 122, 1}, {127, 65535, -3}, },
            {{0, 65535, -3}, },
            {},
            {{0, 65535, -3}, },
            {{0, 65535, -3}, },
            {{111, 111, 334}, },
            {{114, 114, 335}, },
            {{110, 110, 336}, },
            {{113, 113, 337}, },
            {{110, 110, 338}, },
            {{117, 117, 339}, },
            {{112, 112, 340}, },
            {{115, 115, 341}, },
            {{101, 101, 342}, },
            {{101, 101, 343}, },
            {{111, 111, 344}, },
            {},
            {{100, 100, 345}, },
            {{101, 101, 346}, },
            {{117, 117, 347}, },
            {{100, 100, 348}, },
            {{121, 121, 349}, },
            {{116, 116, 350}, },
            {},
            {{112, 112, 351}, },
            {{108, 108, 352}, },
            {},
            {{100, 100, 353}, },
            {},
            {},
            {},
            {},
            {{116, 116, 354}, },
            {{110, 110, 355}, },
            {{117, 117, 356}, },
            {{112, 112, 357}, },
            {},
            {},
            {{100, 100, 358}, },
            {},
            {},
            {{101, 101, 359}, },
            {{117, 117, 360}, },
            {{105, 105, 361}, },
            {},
            {{108, 108, 362}, },
            {{101, 101, 363}, },
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -3}, },
            {{0, 100, -220}, {101, 101, 364}, {102, 65535, -220}, },
            {},
            {},
            {},
            {},
            {},
            {{99, 99, 365}, },
            {},
            {{101, 101, 366}, },
            {{114, 114, 367}, },
            {},
            {{110, 110, 368}, },
            {},
            {{115, 115, 369}, },
            {{98, 98, 370}, },
            {},
            {{115, 115, 371}, },
            {{115, 115, 372}, },
            {},
            {{108, 108, 373}, },
            {{97, 97, 374}, },
            {{111, 111, 375}, },
            {},
            {{98, 98, 376}, },
            {{101, 101, 377}, },
            {},
            {{115, 115, 378}, },
            {{98, 98, 379}, },
            {{110, 110, 380}, },
            {},
            {{116, 116, 381}, },
            {{0, 65535, -3}, },
            {{104, 104, 382}, },
            {},
            {},
            {},
            {},
            {},
            {{101, 101, 383}, },
            {},
            {},
            {},
            {},
            {{115, 115, 384}, },
            {},
            {},
            {},
            {{117, 117, 385}, },
            {{101, 101, 386}, },
            {},
            {{116, 116, 387}, },
            {{101, 101, 388}, },
            {{115, 115, 389}, },
            {{113, 113, 390}, },
            {},
            {{116, 116, 391}, },
            {},
            {},
            {{101, 101, 392}, },
            {{113, 113, 393}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {62, 62, 62, 10, 11, 21, 35, 60, 62, 61, 39, 59, 0, 27, 62, 62, 62, 62, 62, 62, 62, 4, 50, 62, 62, 62, 62, 62, 62, 53, 40, 38, 39, 24, 59, 21, 5, 6, 52, 34, 44, 55, 48, 46, 12, 36, 37, 43, 10, 11, 7, 0, 23, 61, 4, 60, 28, 53, 31, 35, 51, 16, 15, 40, 32, 54, 57, 58, 14, 2, 3, 1, 30, 13, 9, 26, 25, 18, 17, 47, 45, 49, 22, 19, 20, 41, 42, 29, 56, 24, -1, -1, -1, -1, 5, 23, -1, 54, 16, 33, 32, 8, 33, 8, 56, -1, 3, -1, 57, 17, 36, -1, -1, 30, 58, 62, 62, 62, 62, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, 62, 62, 51, 62, 7, -1, 18, 31, 43, 47, 44, 48, 1, -1, 55, -1, 14, 19, 37, 45, 46, 34, 6, 52, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, 62, 38, 62, 62, 12, 20, 2, 42, 41, 49, 62, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 59, -1, -1, -1, -1, -1, -1, -1, 58, -1, -1, -1, 57, -1, -1, 51, -1, 53, 6, 54, -1, -1, 56, -1, -1, 52, -1, -1, -1, -1, 55, -1, -1, -1, -1, -1, -1, -1, -1, -1, 28, 62, 62, 13, 29, 26, 25, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 40, -1, -1, -1, -1, -1, -1, 50, -1, -1, 34, -1, 35, 37, 36, 38, -1, -1, -1, -1, 43, 45, -1, 47, 39, -1, -1, -1, 42, -1, -1, 49, 44, 46, 41, 48, 9, 62, 5, 26, 25, 32, 33, -1, 28, -1, -1, 13, -1, 24, -1, -1, 30, -1, -1, 27, -1, -1, -1, 23, -1, -1, 31, -1, -1, -1, 29, -1, 22, -1, 9, 16, 15, 17, 19, -1, 11, 10, 21, 12, -1, 22, 18, 20, -1, 14, 8, -1, -1, -1, -1, 7, -1, 4, 3, 2, -1, 1, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
